<template>
    <div class="">
            <b-modal @hidden="reset"  size="lg" ref="phyModal" id="my-modal-assurance" :title="ModalTitle"  :hide-footer="true">
                <form class="" method="POST"  @submit.prevent="update()"
                      @reset.prevent="reset()"
                      @keydown="form.errors.clear($event.target.name)"
                      @change="form.errors.clear($event.target.name)">
                                        <div class="form-row">
                                                            <div class="form-group col-md-12">
                                                                <label class="">Volume du réservoir (En Litre)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="volume_reservoir" v-model="form.volume_reservoir" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('volume_reservoir')" v-text="form.errors.get('volume_reservoir')"></span>
                                                            </div>
                                            
                                                            <div class="form-group col-md-12">
                                                                <label class="">Volume du coffre (En Litre)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="volume_coffre" v-model="form.volume_coffre" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('volume_coffre')" v-text="form.errors.get('volume_coffre')"></span>
                                                            </div>
                                                    </div>

                                                    <div class="form-row">
                                                            <div class="form-group col-md-6">
                                                                <label class="">Longueur (En m)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="longueur" v-model="form.longueur" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('longueur')" v-text="form.errors.get('longueur')"></span>
                                                            </div>
                                                            <div class="form-group col-md-6">
                                                                <label class="">Largeur (En m)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="largeur" v-model="form.largeur" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('largeur')" v-text="form.errors.get('largeur')"></span>
                                                            </div>
                                                            <div class="form-group col-md-6">
                                                                <label class="">Hauteur (En m)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="hauteur" v-model="form.hauteur" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('hauteur')" v-text="form.errors.get('hauteur')"></span>
                                                            </div>
                                                            <div class="form-group col-md-6">
                                                                <label class="">Poids (En Kg)</label>
                                                                <input  class="form-control form-control-md form-custom-input-sm" name="poids" v-model="form.poids" type="text" />

                                                                <span class="m-form__help m--font-danger"  v-if="form.errors.has('poids')" v-text="form.errors.get('poids')"></span>
                                                            </div>
                                                        </div>              
                    <div class="m-form__actions m-form__actions--solid mt-3" style="    display: flex;align-items: center;justify-content: flex-end;">
                        <button type="submit" :class="['btn btn-success btn-small ',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
                    </div>
                </form>
            </b-modal>
            <!-- Modal fin -->
        </div>
</template>

<script>

    import Form from "./../../classes/Form"


    export default {
        props:[],
        data(){
            return{
                //VC-calendar
                mask:{

                    input: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                    data: ['L', 'YYYY-MM-DD', 'YYYY/MM/DD'],
                },
                date_pmc:"",

                //multi-select
                marque:"",
                modele:"",
                motorisation:"",
                permis:"",
                tvehicule:"",

                //Options selectionnées
                plaisirs : [],
                conforts : [],
                securites : [],

                modeles : [],
                opt:{
                    marques:[],
                    motorisations:[],
                    tvehicules:[],
                    optConfort:[],
                    optPlaisir:[],
                    optSecurite:[],
                    tpermis:[],
                },
                form : new Form(
                    {
                        image_mise_en_avant:"",
                        images:[],
                        marque_id:"",
                        modele_id:"",
                        libelle:"",
                        type_vehicule_id: "",
                        type_permis_id: "",
                        step:0,

                        options:[],

                        nbr_place: "",
                        nbr_porte: "",
                        couleur: "",

                        //tarifs
                        tarif: "",
                        kilometrage: "",

                        //unicités
                        plaque_immatriculation: "",
                        nr_chassis: "",

                        date_mise_en_circulation: "",
                        annee_mise_en_circulation: "",
                        consommation_au_100_km: "",

                        //moteurs
                        type_motorisation_id: "",
                        boite_vitesse: "",

                        //mesures physiques
                        volume_coffre: "",
                        volume_reservoir: "",
                        largeur: "",
                        longueur: "",
                        poids: "",
                        hauteur: ""
                  }),
                isLoading:false,
            }
        },
        created()
        {
               this.modeEdit = false
               axios.get("/api/dispatcher/options/vehicules").then((response) =>
                {
                      this.opt.marques = response.data.marques.filter( e => {

                       return  e.modeles.length>0
                      })
                      this.opt.motorisations = response.data.motorisations
                      this.opt.tpermis = response.data.tpermis
                      this.opt.tvehicules = response.data.tvehicules


                      //envoie un event pour signifier le chargement des options
                },
                (error) =>
                {
                  this.isLoading = false
                });
             
          
        },
        mounted() {

              window.event.$on('change-physique-event',(vehicule) =>
             {
                 this.entity = vehicule
                 this.showModal()
             })
        },
        computed:
            {
                ModalTitle ()
                {
                    return "Modification : Données physiques"
                },
                ModalAction ()
                {
                    return  " Valider"
                },
                Modeles()
                {
                if(this.marque==null || this.marque=="" || this.marque==undefined)
                return  []
                else
                return this.marque.modeles
                },
            },
        methods:
            {

                //Event sur le date picker
                datepickerEvent(event,name)
                {
                    if(name=="date_dbt")
                    {
                        this.form.date_dbt = moment(event).format('YYYY-MM-DD')
                        this.form.checkError

                    }
                    if(name=="date_fin")
                    {
                    this.form.date_fin = moment(event).format('YYYY-MM-DD')
                    this.form.checkError
                    }
                },
                //Actualise les données générales
                update()
                {
                    //Requête ajax
                    this.isLoading = true
                    this.form.patch("/api/vehicules/"+this.entity.id+"/dimensions").then((response) =>
                        {
                            if(response.success)
                            {
                             flash("<span>Modifié <strong>avec succès</strong></span>")
                             window.event.$emit('updated-physique-event',response.entity)
                            }
                            else
                            {
                             flash("<span>Ajout<strong> impossible</strong></span>","error")
                            }
                            this.reset()
                            this.isLoading = false

                        },
                        (error) =>
                        {
                            this.isLoading = false
                        });
                },
                //On affiche le modal 
                showModal()
                {

                    this.modeEdit = false
                    this.init()
                    this.$refs['phyModal'].show()

                },

                //Initialisation du formulaire
                reset()
                {
                    this.form.volume_coffre= "",
                    this.form.volume_reservoir= "",
                    this.form.largeur= "",
                    this.form.longueur= "",
                    this.form.poids= "",
                    this.form.hauteur= "",
                    this.$refs['phyModal'].hide()
                    this.modeEdit = false
                    this.isLoading = false
                },
                init()
                {
                    this.form.marque_id=this.entity.marque_id,
                    this.form.modele_id=this.entity.modele_id,
                    this.form.libelle=this.entity.libelle,
                    this.form.type_vehicule_id= this.entity.type_vehicule_id,
                    this.form.type_permis_id= this.entity.type_permis_id,
                    this.form.type_motorisation_id= this.entity.type_motorisation_id,

                    this.form.nbr_place= this.entity.nbr_place,
                   this.form. nbr_porte= this.entity.nbr_porte,
                   this.form.couleur= this.entity.couleur,

                    //tarifs
                    this.form.tarif= this.entity.tarif,
                    this.form.kilometrage= this.entity.kilometrage,

                    //unicités
                    this.form.plaque_immatriculation= this.entity.plaque_immatriculation,
                    this.form.nr_chassis= this.entity.nr_chassis,

                    this.form.date_mise_en_circulation= this.entity.date_mise_en_circulation,
                    this.date_pmc = moment(this.form.date_mise_en_circulation).toDate()

                    this.form.annee_mise_en_circulation= moment(this.form.date_mise_en_circulation).year(),
                    this.form.consommation_au_100_km= this.entity.consommation_au_100_km,

                    //moteurs

                    this.form.boite_vitesse= this.entity.boite_vitesse,

                    //mesures physiques
                    this.form.volume_coffre= this.entity.volume_coffre,
                    this.form.volume_reservoir= this.entity.volume_reservoir,
                    this.form.largeur= this.entity.largeur,
                    this.form.longueur= this.entity.longueur,
                    this.form.poids= this.entity.poids,
                    this.form.hauteur= this.entity.hauteur,

                    this.marque = this.opt.marques.find(e =>  e.id == this.form.marque_id)
                    this.modele = this.marque.modeles.find(e =>  e.id == this.form.modele_id)
                    this.motorisation = this.opt.motorisations.find(e => e.id == this.form.type_motorisation_id )
                    this.tvehicule = this.opt.tvehicules.find(e =>  e.id == this.form.type_vehicule_id)

            },

            },
        components:
            {

            }
    }
</script>
